/*
 * Copyright (C) 2009-2011 Dennis Schneider
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *		notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *		notice, this list of conditions and the following disclaimer in the
 *		documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "config.h"
#include "uip-appcall.h"
#include "avrutils.h"
#include "uip/uip.h"
#include "uip/uip-split.h"
#include "enc0.h"
#include "ntpd.h"
#include "amish_uip.h"

void uip_app_init(void) {
	ntpd_init();
	amish_uip_init();
}

void uip_app_periodic(void) {
	uint8_t i;
	i = 0;
	do {
		uip_periodic(i);
		if(uip_len > 0)
			uip_split_output();
	} while(++i < UIP_CONNS);

	i = 0;
	do {
		uip_udp_periodic(i);
		if(uip_len > 0)
			enc0_send_packet();
	} while(++i < UIP_UDP_CONNS);
}

void uip_appcall(void) {
	switch(uip_conn->lport) {
	case HTONS(AMISH_TCP_PORT):
		amish_uip_appcall();
		break;
	}
}

void uip_udp_appcall(void) {
	switch(uip_udp_conn->lport) {
	case HTONS(NTP_PORT):
		ntpd_process_pkt();
		break;
	}
}
