/*
 * Copyright (C) 2009-2010 Dennis Schneider
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "uip/uip.h"
#include "avrutils.h"

void uip_ipaddr_copy_(uip_ipaddr_t *dst, uip_ipaddr_t *src) {
	((uint32_t8 *)dst)->val = ((uint32_t8 *)src)->val;
}

uint8_t uip_ipaddr_cmp_(uip_ipaddr_t *a, uip_ipaddr_t *b) {
	return *(uint32_t *)a == *(uint32_t *)b;
}

void uip_add32(u8_t *op32, u16_t op16) {
	/* 
	 * op32 is in network byte order, op16 in host byte order.
	 * So simply convert op32 to host byte order, add op16 and convert it back.
	 */

	uint32_t8 acc;
	acc.b4 = op32[0];
	acc.b3 = op32[1];
	acc.b2 = op32[2];
	acc.b1 = op32[3];
	acc.val += op16;
	uip_acc32[0] = acc.b4;
	uip_acc32[1] = acc.b3;
	uip_acc32[2] = acc.b2;
	uip_acc32[3] = acc.b1;
}

